# class YAML::Builder

- YAML::Builder
- Reference
- Object

## Overview

A YAML builder generates valid YAML.

A `YAML::Error` is raised if attempting to generate an invalid YAML (for example, if invoking `#end_sequence` without a matching `#start_sequence`)

    require "yaml"

    string = YAML.build do |yaml|
      yaml.mapping do
        yaml.scalar "foo"
        yaml.sequence do
          yaml.scalar 1
          yaml.scalar 2
        end
        yaml.scalar "bar"
        yaml.mapping do
          yaml.scalar "baz"
          yaml.scalar "qux"
        end
      end
    end
    string # => "---\nfoo:\n- 1\n- 2\nbar:\n  baz: qux\n"

## Defined in:

## Constructors

- .new(io : IO)

  Creates a `YAML::Builder` that will write to the given `IO`.

- .new(io : IO, &block)

  Creates a `YAML::Builder` that will write to the given `IO`, invokes the block and closes the builder.

## Instance Method Summary

- #alias(anchor : String)
- #close

  Closes the builder, freeing up resources.

- #document(&block)

  Starts a document, invokes the block, and then ends it.

- #end_document

  Ends a document.

- #end_mapping

  Ends a mapping.

- #end_sequence

  Ends a sequence.

- #end_stream

  Ends a YAML stream.

- #finalize
- #flush

  Flushes any pending data to the underlying `IO`.

- #mapping(anchor : String? = nil, tag : String? = nil, style : YAML::MappingStyle = YAML::MappingStyle::ANY, &block)

  Starts a mapping, invokes the block, and then ends it.

- #max_nesting : Int32

  By default the maximum nesting of sequences/amppings is 99.

- #max_nesting=(max_nesting)

  By default the maximum nesting of sequences/amppings is 99.

- #scalar(value, anchor : String? = nil, tag : String? = nil, style : YAML::ScalarStyle = YAML::ScalarStyle::ANY)

  Emits a scalar value.

- #sequence(anchor : String? = nil, tag : String? = nil, style : YAML::SequenceStyle = YAML::SequenceStyle::ANY, &block)

  Starts a sequence, invokes the block, and the ends it.

- #start_document

  Starts a document.

- #start_mapping(anchor : String? = nil, tag : String? = nil, style : YAML::MappingStyle = YAML::MappingStyle::ANY)

  Starts a mapping.

- #start_sequence(anchor : String? = nil, tag : String? = nil, style : YAML::SequenceStyle = YAML::SequenceStyle::ANY)

  Starts a sequence.

- #start_stream

  Starts a YAML stream.

- #stream(&block)

  Starts a YAML stream, invokes the block, and ends it.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO)
inspect inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s
to_s(io : IO) to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(io : IO) #

Creates a `YAML::Builder` that will write to the given `IO`.

def self.new(io : IO, &block) #

Creates a `YAML::Builder` that will write to the given `IO`, invokes the block and closes the builder.

## Instance Method Detail

def alias(anchor : String) #
def close #

Closes the builder, freeing up resources.

def document(&block) #

Starts a document, invokes the block, and then ends it.

def end_document #

Ends a document.

def end_mapping #

Ends a mapping.

def end_sequence #

Ends a sequence.

def end_stream #

Ends a YAML stream.

def finalize #
def flush #

Flushes any pending data to the underlying `IO`.

def mapping(anchor : String? = nil, tag : String? = nil, style : YAML::MappingStyle = YAML::MappingStyle::ANY, &block) #

Starts a mapping, invokes the block, and then ends it.

def max_nesting : Int32 #

By default the maximum nesting of sequences/amppings is 99. Nesting more than this will result in a YAML::Error. Changing the value of this property allows more/less nesting.

def max_nesting=(max_nesting) #

By default the maximum nesting of sequences/amppings is 99. Nesting more than this will result in a YAML::Error. Changing the value of this property allows more/less nesting.

def scalar(value, anchor : String? = nil, tag : String? = nil, style : YAML::ScalarStyle = YAML::ScalarStyle::ANY) #

Emits a scalar value.

def sequence(anchor : String? = nil, tag : String? = nil, style : YAML::SequenceStyle = YAML::SequenceStyle::ANY, &block) #

Starts a sequence, invokes the block, and the ends it.

def start_document #

Starts a document.

def start_mapping(anchor : String? = nil, tag : String? = nil, style : YAML::MappingStyle = YAML::MappingStyle::ANY) #

Starts a mapping.

def start_sequence(anchor : String? = nil, tag : String? = nil, style : YAML::SequenceStyle = YAML::SequenceStyle::ANY) #

Starts a sequence.

def start_stream #

Starts a YAML stream.

def stream(&block) #

Starts a YAML stream, invokes the block, and ends it.